# These macros reflect the locations and user Apache is configured to
# run with and as on RHL 7.x.

# First, where documents are stored.  This affects where icons are placed.
%define contentdir /var/www

# Now the place where mailman binaries go.
%define mmdir /var/mailman

# Now the place where mutable data goes.
%define varmmdir /var/mailman

# Now, the user and group the CGIs will expect to be run under.  This should
# match the user and group the web server is configured to run as.  The scripts
# will error out if they are invoked by any other user.
%define cgiuser    apache
%define cgiuserid  48
%define cgigroup   apache
%define cgigroupid 48

# Now, the user and group the scripts will actually execute as.
%define user       mailman
%define userid     41
%define group      mailman
%define groupid    41

# Now, the groups your mail spoolers run as.  Sendmail uses 'mail'(12)
# and postfix uses 'nobody'(99).
%define mailgroup  mail,nobody
%define mailgid    12,99

# If you want to enable alpha quality patches:
#	rpm --rebuild --define 'alpha_code 1' mailman-XXX.src.rpm
%{!?alpha_code:%define alpha_code 0}

Summary: Mailing list manager with built in Web access.
Name: mailman
Version: 2.0.12
%if %{alpha_code}
Release: 2a
%else
Release: 2
%endif
Epoch: 3
Group: Applications/Internet
#Source0: ftp://ftp.gnu.org/pub/gnu/mailman/mailman-%{version}.tgz
#Source0: http://prdownloads.sourceforge.net/mailman/mailman-%{version}.tgz
Source0: mailman-%{version}.tar.bz2
Source1: mm_cfg.py
Source2: mailman-README.REDHAT
Source3: httpd-mailman.conf
Source4: mailman.logrotate
Patch1: mailman-2.0.3-custom-list-templates.patch
Patch2: mailman-2.0.4-handle_opts-doc_init.patch
Patch3: mailman-2.0.12-subscribe_unknown-addr_use-template.patch
Patch4: mailman-2.0.4-subscribe-doc_init.patch
Patch5: mailman-2.0.4-custom-subscribeack-subject.patch
Patch6: mailman-2.0.4-subscribeack-useradds.patch
Patch7: mailman-2.0.5-SMTPDirect-useraddr_in_msg_parsing.patch
Patch8: mailman-2.0.5-subscribeack-replyto.patch
Patch9: mailman-2.0.12-options_unknown-addr_use-template.patch
Patch10: mailman-2.0.9-multimail.patch
Patch11: mailman-2.0.9-admin.patch
Patch12: mailman-2.0.11-disable_user_passwords.patch
Patch13: mailman-2.0.12-MailCommandHandler-python152.patch
License: GPL
URL: http://www.list.org/
BuildRoot: %{_tmppath}/%{name}-root
Prereq: shadow-utils, /usr/bin/newaliases, /usr/bin/crontab
Requires: webserver, python >= 1.5.2, mktemp

%description 
Mailman is software to help manage email discussion lists, much like
Majordomo and Smartmail. Unlike most similar products, Mailman gives
each mailing list a webpage, and allows users to subscribe,
unsubscribe, etc. over the Web. Even the list manager can administer
his or her list entirely from the Web. Mailman also integrates most
things people want to do with mailing lists, including archiving, mail
<-> news gateways, and so on.

When the package has finished installing, you will need to:

* Run %{mmdir}/bin/mmsitepass to set the mailman administrator password.
* Edit %{mmdir}/Mailman/mm_cfg.py to configure Mailman for your site.
* Add "Include conf/httpd-mailman.conf" to /etc/httpd/conf/httpd.conf.

Users upgrading from previous releases of this package may need to
move their data or adjust the configuration files to point to the
locations where their data is.

%prep
%setup -q
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1 -b .multimail
%patch11 -p1 -b .admin
%if %{alpha_code}
%patch12 -p1
%endif
%patch13 -p1
cp $RPM_SOURCE_DIR/mailman-README.REDHAT README.REDHAT
aclocal
autoconf

%build
CFLAGS="$RPM_OPT_FLAGS"; export CFLAGS
FQDN=localhost.localdomain \
URL=localhost.localdomain \
MAILMAN_UID=%{userid} \
MAILMAN_GID=%{groupid} \
MAIL_GID=%{mailgid} \
CGI_UID=%{cgiuserid} \
CGI_GID=%{cgigroupid} \
./configure \
	--prefix=%{mmdir} \
	--with-var-prefix=%{varmmdir} \
	--with-python=%{__python} \
	--with-mail-gid=%{mailgroup} \
	--with-cgi-id=%{cgiuser} \
	--with-cgi-gid=%{cgigroup}
cp %{SOURCE1} Mailman/mm_cfg.py.dist
make
	
%install
rm -fr $RPM_BUILD_ROOT
# Normal install.
make install prefix=$RPM_BUILD_ROOT%{mmdir} var_prefix=$RPM_BUILD_ROOT%{varmmdir}

# Create directories we'll use for log and spool files.
install -m775 -d $RPM_BUILD_ROOT/var/log/mailman
install -m775 -d $RPM_BUILD_ROOT/var/spool/mailman/qfiles

# Clean out any byte-compiled python modules and recompile them.
find $RPM_BUILD_ROOT%{mmdir} -name "*.pyc" -exec rm -fv '{}' ';'
python -c 'from compileall import *; compile_dir("'$RPM_BUILD_ROOT'%{mmdir}",10,"%{mmdir}")'

# Copy the icons into the web server's icons directory.
mkdir -p $RPM_BUILD_ROOT%{contentdir}/icons
cp misc/*.jpg misc/*.png $RPM_BUILD_ROOT%{contentdir}/icons

# Create a link to the wrapper in /etc/smrsh to allow sendmail to run it.
mkdir -p $RPM_BUILD_ROOT/etc/smrsh
ln -s ../..%{mmdir}/mail/wrapper $RPM_BUILD_ROOT/etc/smrsh/wrapper
diff -u $RPM_BUILD_ROOT/%{mmdir}/mail/wrapper $RPM_BUILD_ROOT/etc/smrsh/wrapper

# Install a logrotate control file.
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m644 $RPM_SOURCE_DIR/mailman.logrotate $RPM_BUILD_ROOT/etc/logrotate.d/mailman

# Install the httpd configuration file.
install -m755 -d $RPM_BUILD_ROOT/etc/httpd/conf
install -m644 /dev/null $RPM_BUILD_ROOT/etc/httpd/conf/httpd-mailman.conf
sed -e 's|@VARMMDIR@|%{varmmdir}|g' -e 's|@MMDIR@|%{mmdir}|g' \
	$RPM_SOURCE_DIR/httpd-mailman.conf > \
	$RPM_BUILD_ROOT/etc/httpd/conf/httpd-mailman.conf

%clean
rm -rf $RPM_BUILD_ROOT $RPM_BUILD_DIR/files.%{name}

%pre
/usr/sbin/useradd -s /bin/false -c "GNU Mailing List Manager" -d %{mmdir} -M -r -u 41 mailman 2> /dev/null || :

%post
if [ ! -f /var/spool/cron/mailman ]; then
  crontab -u mailman %{mmdir}/cron/crontab.in
fi
if ! grep -q "mailman-owner" /etc/aliases 2> /dev/null ; then
  cat >> /etc/aliases << EOF
# mailman aliases
mailman: postmaster
mailman-owner: mailman
EOF
  /usr/bin/newaliases > /dev/null 2>&1 || :
fi

%postun
if [ $1 = 0 ]; then
  crontab -u mailman -r
  TMPFILE=`mktemp /etc/aliasesXXXXXX`
  if test -n "$TMPFILE" ; then
    egrep -E -v 'mailman aliases|mailman:|mailman-owner:' /etc/aliases >${TMPFILE}
    mv ${TMPFILE} /etc/aliases
  fi
  /usr/bin/newaliases > /dev/null 2>&1 || :
fi

%files
%defattr(-,root,root)
%doc ACKNOWLEDGMENTS BUGS FAQ NEWS README README.LINUX TODO UPGRADING INSTALL
%doc gnu-COPYING-GPL README.REDHAT README.SENDMAIL README.QMAIL README.EXIM
%attr(0644,root,root) %{contentdir}/icons/*
%dir %{mmdir}
#%dir %{varmmdir}
%config %{mmdir}/Mailman
%config /etc/smrsh/wrapper
%config /etc/logrotate.d/mailman
%config /etc/httpd/conf/httpd-mailman.conf

%dir %{mmdir}/bin
%dir %{mmdir}/cgi-bin
%attr(2755,root,mailman) %{mmdir}/bin/*
%attr(2755,root,mailman) %{mmdir}/cgi-bin/*
%attr(2755,root,mailman) %{mmdir}/cron/
%attr(2775,root,mailman) %{mmdir}/mail/

%dir %{mmdir}/scripts/
%attr(2755,root,mailman) %{mmdir}/scripts/*

%config %{mmdir}/templates

%dir %attr(2775,root,mailman) %{varmmdir}/archives/
%attr(2775,root,mailman) %{varmmdir}/archives/public/
%attr(2771,root,mailman) %{varmmdir}/archives/private/

%attr(2775,root,mailman) %{varmmdir}/data/
%attr(2775,root,mailman) %{varmmdir}/filters/
%attr(2775,root,mailman) %{varmmdir}/lists/
%attr(2775,root,mailman) %{varmmdir}/locks/
%attr(2755,root,mailman) %{varmmdir}/spam/
%attr(2775,root,mailman) /var/log/mailman
%attr(2775,root,mailman) /var/spool/mailman

%changelog
* Thu Jul 18 2002 Peter Hanecak <hanecak@megaloman.sk> 2.0.12-2
- MailCommandHandler.py patched so it works with python-1.5.2

* Thu Jul 18 2002 Peter Hanecak <hanecak@megaloman.sk> 2.0.12-1
- update to 2.0.12
- updated subscribe_unknown-addr_use-template and
  options_unknown-addr_use-template patches

* Tue Jul  9 2002 Peter Hanecak <hanecak@megaloman.sk> 2.0.11-3
- added alpha quality 'disable user passwords' patch

* Wed Jul  3 2002 Peter Hanecak <hanecak@megaloman.sk> 2.0.11-2
- synchronized with RedHat's mailman-2.0.11-1 package

* Fri May 24 2002 Peter Hanecak <hanecak@megaloman.sk>
- update to 2.0.11
- synchronized with RedHat's mailman-2.0.9-1 package

* Fri Apr  5 2002 Nalin Dahyabhai <nalin@redhat.com>
- include README.QMAIL in with the docs (#58887)
- include README.SENDMAIL and README.EXIM in with the docs
- use an included httpd.conf file instead of listing the configuration
  directives in the %%description, which due to specspo magic might look
  wrong sometimes (part of #51324)
- interpolate the DEFAULT_HOST_NAME value in mm.cfg into both the DEFAULT_URL
  and MAILMAN_OWNER (#57987)
- move logs to /var/log/mailman, qfiles to /var/spool/mailman, rotate
  logs in the log directory (#48724)
- raise exceptions when someone tries to set the admin address for a list
  to that of the admin alias (#61468)

* Thu Apr  4 2002 Nalin Dahyabhai <nalin@redhat.com>
- fix a default permissions problem in %{_var}/mailman/archives/private,
  reported by Johannes Erdfelt
- update to 2.0.9

* Tue Apr  2 2002 Nalin Dahyabhai <nalin@redhat.com>
- make the symlink in /etc/smrsh relative

* Mon Feb 25 2002 Peter Hanecak <hanecak@megaloman.sk>
- applied forgotten mailman-2.0.3-custom-list-templates.patch patch

* Thu Jan 24 2002 Peter Hanecak <hanecak@megaloman.sk>
- synchronized with RedHat's mailman-2.0.8-1 package
- options_unknown-addr_use-template.patch updated

* Tue Dec 11 2001 Nalin Dahyabhai <nalin@redhat.com> 2.0.8-1
- set FQDN and URL at build-time so that they won't be set to the host the
  RPM package is built on (#59177)

* Wed Nov 28 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.0.8

* Sat Nov 17 2001 Florian La Roche <Florian.LaRoche@redhat.de> 2.0.7-1
- update to 2.0.7

* Wed Jul 25 2001 Nalin Dahyabhai <nalin@redhat.com> 2.0.6-1
- update to 2.0.6

* Mon Jun 25 2001 Nalin Dahyabhai <nalin@redhat.com>
- code in default user/group names/IDs

* Wed May 30 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.0.5
- change the default hostname from localhost to localhost.localdomain in the
  default configuration
- chuck configuration file settings other than those dependent on the host name
  (the build system's host name is not a good default)  (#32337)

* Fri May 11 2001 Peter Hanecak <hanecak@megaloman.sk>
- options.py patched to use options-error.html template when reporting
  "No such member" error

* Fri May 11 2001 Peter Hanecak <hanecak@megaloman.sk>
- Deliver.py patched to include Reply-To header in subscribeack message

* Fri May 11 2001 Peter Hanecak <hanecak@megaloman.sk>
- fixed SMTPDirect.py patch (to parse "%%(useradds)s" in msgtext for each
  recipient)

* Thu May 10 2001 Peter Hanecak <hanecak@megaloman.sk>
- updated to 2.0.5

* Wed May  9 2001 Peter Hanecak <hanecak@megaloman.sk>
- SMTPDirect.py patched to parse "%%(useradds)s" in msgtext for each recipient

* Mon May  7 2001 Peter Hanecak <hanecak@megaloman.sk>
- Deliver.py:
  - patched to allow list specific subjects in subscribe acknowledge messages
  - patched to allow %%(useraddr)s in template

* Tue May  1 2001 Peter Hanecak <hanecak@megaloman.sk>
- subscribe.py patch to use subscribe.html template when reporting
  "LIST has no subscribed addr ADDR" error
- subscribe.py patch to fix headers in HTML output

* Wed Apr 25 2001 Peter Hanecak <hanecak@megaloman.sk>
- handle_opts.py patch to fix headers in HTML output

* Wed Apr 25 2001 Peter Hanecak <hanecak@megaloman.sk>
- updated to 2.0.4

* Mon Apr  9 2001 Peter Hanecak <hanecak@megaloman.sk>
- patched to allow list specific templates

* Wed Apr  4 2001 Peter Hanecak <hanecak@megaloman.sk>
- added CGI scripts
- fixed %%{prefixdir} permissions (group changed from mailman to mail)

* Mon Apr  2 2001 Peter Hanecak <hanecak@megaloman.sk>
- fixed missing wrapper

* Mon Mar 26 2001 Peter Hanecak <hanecak@megaloman.sk>
- updated to 2.0.3
- '%%define contentdir /var/www' used
- /usr/sbin/useradd added to Prereq
- %%configure used
- --with-cgi-gid=99 changed to --with-cgi-gid=48 - we are running apache as
  user 'apache' (uid 48, gid 48)
- it looks like instalation creates proper files in cgi-bin directory so
  maybe we can do www or cgi subpackage in the near future

* Tue Mar 13 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.0.3

* Tue Mar  6 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.0.2

* Tue Mar 06 2001 Lenny Cartier <lenny@mandrakesoft.com> 2.0.2-1mdk
- updated to 2.0.2

* Wed Feb 21 2001 Nalin Dahyabhai <nalin@redhat.com>
- patch from Barry Warsaw (via mailman-developers) to not die on
  broken Content-Type: headers

* Fri Jan 19 2001 Vincent Danen <vdanen@mandrakesoft.com> 2.0.1-1mdk
- 2.0.1
- fix url
- move /home/httpd to /var/www

* Tue Jan  9 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.0.1

* Mon Dec 11 2000 Lenny Cartier <lenny@mandrakesoft.com> 2.0-1mdk
- change user
- used srpm from Stefane Fermigier <sf@fermigier.com>

* Wed Dec  6 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.0 final release
- move the data to %{_var}

* Fri Oct 20 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to beta 6

* Thu Aug  3 2000 Nalin Dahyabhai <nalin@redhat.com>
- add note about adding FollowSymlinks so that archives work

* Wed Aug  2 2000 Nalin Dahyabhai <nalin@redhat.com>
- make the default owner root again so that root owns the docs
- update to 2.0beta5, which fixes a possible security vulnerability
- add smrsh symlink

* Mon Jul 24 2000 Prospector <prospector@redhat.com>
- rebuilt

* Wed Jul 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to beta4
- change uid/gid to apache.apache to match apache (#13593)
- properly recompile byte-compiled versions of the scripts (#13619)
- change mailman alias from root to postmaster

* Sat Jul  1 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to beta3
- drop bugs and arch patches (integrated into beta3)

* Tue Jun 27 2000 Nalin Dahyabhai <nalin@redhat.com>
- move web files to reside under %{contentdir}
- move files from /usr/share to %{_datadir}
- integrate spot-fixes from mailman lists via gnome.org

* Mon Jun 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- rebuild for Power Tools

* Mon Jun 05 2000 Andreas Hasenack <andreas@conectiva.com>
- now requires smtpdaemon instead of sendmail

* Fri May 26 2000 Eliphas Levy Theodoro <eliphas@conectiva.com>
- added macros and removed warning-things for the testing environment
- added patch to configure so now he don't complain with maildir directory
- changed attribute of maildir directory to 02775 in %files

* Thu May 25 2000 Gustavo Niemeyer <niemeyer@conectiva.com>
- Updated to 2.0beta2
- Updated images

* Wed May 23 2000 Nalin Dahyabhai <nalin@redhat.com>
- Update to 2.0beta2 to pick up security fixes.
- Change Requires: python to list >= 1.5.2

* Mon May 15 2000 Elvis Pftzenreuter <epx@conectiva.com>
- using stackguard compiler
- allows non-root compilation

* Mon Nov  8 1999 Bernhard Rosenkrnzer <bero@redhat.com>
- 1.1

* Wed Sep 15 1999 Rud Moura <ruda@conectiva.com>
- First build for Conectiva
- Adopted by Conectiva Linux

* Tue Sep 14 1999 Preston Brown <pbrown@redhat.com>
- 1.0 final.

* Tue Jun 15 1999 Preston Brown <pbrown@redhat.com>
- security fix for cookies
- moved to /usr/share/mailman

* Fri May 28 1999 Preston Brown <pbrown@redhat.com>
- fix up default values.

* Fri May 07 1999 Preston Brown <pbrown@redhat.com>
- modifications to install scripts

* Thu May 06 1999 Preston Brown <pbrown@redhat.com>
- initial RPM for SWS 3.0
